<?php
/**
 * 2026 Paysera
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * @author Paysera <plugins@paysera.com>
 * @copyright 2026 Paysera
 * @license http://opensource.org/licenses/afl-3.0.php Academic Free License (AFL 3.0)
 * International Registered Trademark & Property of Paysera
 */

declare(strict_types=1);

namespace Paysera\PrestashopPayments\Service;

use Paysera\CheckoutSdk\Entity\PaymentCountry;
use Paysera\PrestashopPayments\Provider\PaymentCountryProviderInterface;

if (!defined('_PS_VERSION_')) {
    exit;
}

class BillingCountryResolver
{
    public function __construct(
        private PaymentCountryProviderInterface $countryProvider
    ) {
    }

    public function resolve(\Context $context): string
    {
        $billingCountry = $this->resolveBillingCountryCode($context);
        $availableCountries = $this->countryProvider->getAvailableCountries();

        return isset($availableCountries[$billingCountry])
            ? $billingCountry
            : PaymentCountry::OTHER_COUNTRIES_CODE
        ;
    }

    private function resolveBillingCountryCode(\Context $context): string
    {
        $cart = $context->cart;
        if ($cart === null || !$cart->id_address_invoice) {
            return '';
        }

        $address = new \Address($cart->id_address_invoice);
        if (!\Validate::isLoadedObject($address) || !$address->id_country) {
            return '';
        }

        $country = new \Country($address->id_country);
        if (!\Validate::isLoadedObject($country)) {
            return '';
        }

        return $country->iso_code;
    }
}
